import unittest
from unittest.mock import patch

from tmc import points
from tmc.utils import load, load_module, reload_module, get_stdout, check_source
from functools import reduce
import os
import os.path
import textwrap
from random import choice, randint
from string import ascii_lowercase

exercise = 'src.password_generator_part_1'
function = "generate_password"

def caseok(s: str):
    return len([x for x in s if x not in ascii_lowercase]) == 0



@points('1.password_generator_part_1')
class PasswordGenerator1Test(unittest.TestCase):
    @classmethod
    def setUpClass(cls):
        with patch('builtins.input', side_effect=[AssertionError("Att be om input från användaren förväntades inte")]):
           cls.module = load_module(exercise, 'en')

    def test_0a_main_program_ok(self):
        ok, line = check_source(self.module)
        message = """Koden för att testa funktionerna ska placeras inuti
if __name__ == "__main__":
block. Följande rad ska flyttas:
"""
        self.assertTrue(ok, message+line)

    def test1_function_exists(self):
        try:
            from src.password_generator_part_1 import generate_password
        except:
            self.assertTrue(False, "Din kod bör innehålla funktionen generate_password(length: int)")

    def test2_type_of_return_value(self):
        try:
            from src.password_generator_part_1 import generate_password
            val = generate_password(2)
            taip = str(type(val)).replace("<class '","").replace("'>","")
            self.assertTrue(type(val) == str,
                f"Funktionen generate_password ska returnera en string. Istället för {val} vilket är en {taip} när parameter (2) används.")
        except:
            self.assertTrue(False, f"Det uppstod ett fel när funktionen anropades med parametervärdet (2)")

    def test3_uses_import_expression(self):
        with open("src/password_generator_part_1.py") as f:
            cont = f.read()
            self.assertTrue("import" in cont and "random" in cont,
                f"Ditt program importerar inte random bibliotek med importuttrycket.")

    def test4_test_with_values(self):
        test_cases = [2, 4, 5, 8, 11, 13, 20]
        for test_case in test_cases:
            with patch('builtins.input', side_effect=[AssertionError("Att be om input från användaren förväntades inte")]):
                reload_module(self.module)
                generate_password = load(exercise, function, 'en')

                val1 = generate_password(test_case)
                val2 = generate_password(test_case)

                self.assertTrue(len(val1) == test_case, f"Lösenordets längd är {len(val1)}, men det bör vara {test_case} när parametern är {test_case}: {val1}")
                self.assertTrue(caseok(val1), f"Lösenordet innehåller andra tecken än gemener: \n{val1} \nnär parametern var {test_case}")
                self.assertTrue(caseok(val2), f"Lösenordet innehåller andra tecken än gemener: \n{val2} \nnär parametern var {test_case}") 
                self.assertNotEqual(val1, val2, f"Att anropa funktionen returnerar samma lösenord varje gång: \n{val1} \nnär parametern är {test_case}")

if __name__ == '__main__':
    unittest.main()